public class Car implements Cloneable
{
	private int yearOfMake;
	private Engine theEngine;
	// The following field if set final now without a problem.
	final private int uniqueID;
	private static int idCount = 0;

	public Car(int year, Engine e)
	{
		yearOfMake = year;
		theEngine = e;	
		uniqueID = idCount++;	
	}

	protected Car(Car other) throws CloneNotSupportedException
	{
		yearOfMake = other.yearOfMake;
		theEngine = (Engine) other.theEngine.clone();
		uniqueID = idCount++;
	}

	public String toString()
	{
		return super.toString() + " : " + yearOfMake + " : " + theEngine.toString();
	}

	public Object clone() throws CloneNotSupportedException
	{
		return new Car(this);
	}
}